/*  openplayer firmware - openplayer, an open source portable music player
    Copyright (C) 2008  Gerard Marull Paretas - <gerardmarull[at]gmail[dot]com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**************************************************************************
 * 
 * Module for MP3 decoder VS1011b - Version 1.0
 * 
 * File type: Header
 * File name: decoder.h
 * 
 **************************************************************************/


#ifndef DECODER_H_
#define DECODER_H_

/********/
/* Misc */
/********/

#define VOL_DEFAULT 0x0f
#define VOL_CHANGE_CONST 15

#define DEC_OP_WRITE 0x02
#define DEC_OP_READ  0x03

#define act_decoder() DEC_PORT &= ~(1<<DEC_XCS)
#define dis_decoder() DEC_PORT |= (1<<DEC_XCS)
#define xdcs_high()   DEC_PORT |= (1<<DEC_XDCS)
#define xdcs_low()    DEC_PORT &= ~(1<<DEC_XDCS)

/*********************/
/* Decoder Registers */
/*********************/
#define DEC_MODE     0x00
#define DEC_STATUS   0x01
#define DEC_BASS     0x02
#define DEC_CLOCKF   0x03
#define DEC_DECTIME  0x04
#define DEC_AUDATA   0x05
#define DEC_WRAM     0x06
#define DEC_WRAMADDR 0x07
#define DEC_HDAT0	 0x08
#define DEC_HDAT1	 0x09
#define DEC_AIADDR   0x0a
#define DEC_VOL		 0x0b
#define DEC_AICTRL0  0x0c
#define DEC_AICTRL1	 0x0d
#define DEC_AICTRL2  0x0e
#define DEC_AICTRL3  0x0f


/***********************/
/* Function prototypes */
/***********************/
uint8_t dec_sendbyte(uint8_t byte);
uint8_t dec_init(void);
void dec_write(uint8_t address, uint16_t val);
uint16_t dec_read(uint8_t address);
void dec_softreset(void);
void dec_setvolume(uint8_t right, uint8_t left);
void dec_datawrite(uint8_t data);
void dec_nulls(uint16_t num);
inline void dec_standby(void);

#endif /*DECODER_H_*/

